<script setup lang="ts">
import { useUserStore } from '@/stores/user'
import type { User } from '@/types/User'
import { nextTick, onMounted, ref, watch } from 'vue'
import type { VForm } from 'vuetify/components'

const props = defineProps<{
  user: User
}>()
const emit = defineEmits<{
  selectedUser: [User]
}>()

emit('selectedUser', props.user)

const userStore = useUserStore()

const dialog = ref(false)
const form = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const refform = ref<VForm | null>(null)

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    userStore.clearForm()
  })
}
async function deleteItemConfirm() {
  // Delete item from list
  await userStore.deleteUser()
  closeDelete()
}
async function editItem(item: User) {
  if (!item.id) return
  await userStore.getUser(item.id)
  dialog.value = true
}
async function deleteItem(item: User) {
  if (!item.id) return
  await userStore.getUser(item.id)
  dialogDelete.value = true
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    userStore.clearForm()
  })
}

async function save() {
  const { valid } = await refform.value!.validate()
  if (!valid) return
  await userStore.saveUser()
  closeDialog()
  if (userStore.editedUser.files != null) {
    refreshPage()
  }
}

function upper1st(str: string | undefined) {
  if (!str) {
    return ''
  }
  return str.charAt(0).toUpperCase() + str.slice(1)
}

function refreshPage() {
  window.location.reload()
}

onMounted(async () => {
  await userStore.getUsers()
})
</script>
<template>
  <v-table :items="userStore.users">
    <v-card class="mx-4 my-12" max-width="600" color="white">
      <v-img cover height="280" :src="'http://localhost:3000/images/users/' + user.image"></v-img>
      <v-card-item>
        <v-card-title style="font-size: 25px">{{ user.fullName }}</v-card-title>
      </v-card-item>
      <v-card-text>
        <v-divider class="mx-4 mb-1"></v-divider>
        <div class="my-4 text-subtitle-1">ID: {{ user.id }}</div>
        <div class="my-4 text-subtitle-1">Email: {{ user.email }}</div>
        <div class="my-4 text-subtitle-1">Username: {{ user.username }}</div>
        <div class="my-4 text-subtitle-1">Gender: {{ upper1st(user.gender) }}</div>
        <div class="my-4 text-subtitle-1">Role: {{ upper1st(user.role) }}</div>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-icon size="small" class="me-2" v-model="dialog" @click="editItem(user)"
            >mdi-pencil</v-icon
          >
          <v-icon size="small" v-model="dialogDelete" @click="deleteItem(user)">
            mdi-delete
          </v-icon>
        </v-card-actions>
      </v-card-text>
      <v-dialog v-model="dialogDelete" width="500px">
        <v-card>
          <br />
          <v-img style="margin-left: 230px" :width="40" src="\src\assets\Login\icon.png"></v-img>
          <v-spacer></v-spacer>
          <v-card-title align="center" class="text-h5">Are you sure?</v-card-title>
          <v-card-title align="center" class="text-h10">
            This action cannot be undone.<br />
            All values associated with this field will be lost.
          </v-card-title>
          <v-spacer></v-spacer>
          <div align="center">
            <div style="margin: 0 auto; max-width: 400px">
              <v-btn
                block
                style="background-color: #e11d48"
                color="white"
                variant="text"
                @click="deleteItemConfirm()"
              >
                Delete field
              </v-btn>
            </div>
          </div>
          <div align="center">
            <div
              style="
                margin: 0 auto;
                max-width: 400px;
                border: 1px solid #dfe1e6;
                border-radius: 5px;
                margin-top: 10px;
              "
            >
              <v-btn block color="primary" variant="text" @click="closeDelete()"> Cancel </v-btn>
            </div>
          </div>
          <v-spacer></v-spacer>
          <br />
        </v-card>
      </v-dialog>
    </v-card>
  </v-table>

  <v-dialog v-model="dialog" persistent width="1024">
    <v-card>
      <v-card-title>
        <span class="text-h5">User</span>
      </v-card-title>
      <v-card-text>
        <v-form ref="refform" v-model="form" @submit.prevent="">
          <v-container>
            <v-row>
              <v-col cols="12" sm="6" md="6">
                <v-text-field
                  v-model="userStore.editedUser.email"
                  :readonly="loading"
                  :rules="[(v) => !!v || 'Please fill data']"
                  class="mb-2"
                  clearable
                  label="Email"
                ></v-text-field>
              </v-col>

              <v-col cols="12" sm="12" md="6">
                <v-text-field
                  v-model="userStore.editedUser.fullName"
                  :readonly="loading"
                  :rules="[(v) => !!v || 'Please fill data']"
                  class="mb-2"
                  clearable
                  label="Full Name"
                ></v-text-field>
              </v-col>

              <v-col cols="12" sm="5" md="6">
                <v-text-field
                  v-model="userStore.editedUser.username"
                  :readonly="loading"
                  :rules="[(v) => !!v || 'Please fill data']"
                  class="mb-2"
                  clearable
                  label="Username"
                ></v-text-field>
              </v-col>

              <v-col cols="12" sm="5" md="6">
                <v-text-field
                  v-model="userStore.editedUser.password"
                  :readonly="loading"
                  :rules="[(v) => !!v || 'Please fill data']"
                  class="mb-2"
                  clearable
                  label="Password"
                ></v-text-field>
              </v-col>

              <v-col cols="12" sm="12" md="2">
                <v-combobox
                  v-model="userStore.editedUser.gender"
                  :readonly="loading"
                  :rules="[(v) => !!v || 'Please fill data']"
                  :items="[
                    { title: 'Male', value: 'male' },
                    { title: 'Female', value: 'female' },
                    { title: 'Others', value: 'others' }
                  ]"
                  label="Gender"
                  :return-object="false"
                ></v-combobox>
              </v-col>

              <v-col cols="12" sm="12" md="2">
                <v-combobox
                  v-model="userStore.editedUser.role"
                  :readonly="loading"
                  :rules="[(v) => !!v || 'Please fill data']"
                  :items="[
                    { title: 'User', value: 'User' },
                    { title: 'Admin', value: 'Admin' }
                  ]"
                  label="Role"
                  :return-object="false"
                ></v-combobox>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-file-input
                  v-model="userStore.editedUser.files"
                  :rules="[
                    (value) => {
                      return (
                        !value ||
                        !value.length ||
                        value[0].size < 5000000 ||
                        'Avatar size should be less than 5 MB!'
                      )
                    }
                  ]"
                  accept="image/png, image/jpeg"
                  label="Avatar"
                  placeholder="Pick an avatar"
                  prepend-icon="mdi-camera"
                ></v-file-input>
              </v-col>
              <v-col cols="12" sm="12" md="4">
                <v-img
                  :src="'http://localhost:3000/images/users/' + userStore.editedUser.image"
                  width="100"
                ></v-img>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
        <small style="color: red">*Please fill data</small>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="primary" variant="text" @click="closeDialog()"> Close </v-btn>
        <v-btn color="primary" variant="text" @click="save()"> Save </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
